package io.p2vman.vmodextras.cc;

import io.p2vman.vmodextras.cc.block.BlockNetworkModem;
import io.p2vman.vmodextras.cc.block.WireNetworkHubBlock;
import io.p2vman.vmodextras.cc.block.entity.NetworkModemEntity;
import net.minecraft.world.item.BlockItem;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.Rarity;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.material.MapColor;
import net.minecraftforge.registries.RegistryObject;
import io.p2vman.vmodextras.cc.block.TrackWorkController;
import io.p2vman.vmodextras.cc.block.entity.TrackWorkControllerEntity;
import io.p2vman.vmodextras.util.ModRegistry;
import io.p2vman.vmodextras.util.Utils;

public class ComputerCraftCompact {
    public static ModRegistry.RegistryContainer NETWORK_MODEM = ModRegistry.RegistryContainer.create("network_modem");
    public static RegistryObject<BlockEntityType<TrackWorkControllerEntity>> TRACK_WORK_CONTROLLER_BLOCK_ENTITY;

    public static RegistryObject<Block> TRACK_WORK_CONTROLLER_BLOCK;
    public static RegistryObject<Item> TRACK_WORK_CONTROLLER_ITEM;

    public static RegistryObject<Block> WIRE_NETWORK_HUB_BLOCK;
    public static RegistryObject<Item> WIRE_NETWORK_HUB_ITEM;

    public static void init(ModRegistry REGISTRY, ModRegistry.TabBuilder builder) {

        NETWORK_MODEM.block(() -> new BlockNetworkModem(BlockBehaviour.Properties.of().mapColor(MapColor.STONE)));
        NETWORK_MODEM.entity(() -> BlockEntityType.Builder.of(NetworkModemEntity::new, NETWORK_MODEM.getBlock().get()).build(null));
        NETWORK_MODEM.item(() -> new BlockItem(NETWORK_MODEM.getBlock().get(), new Item.Properties().rarity(Rarity.EPIC)));

        Utils.executeIsModEnable("trackwork", () -> {
            TRACK_WORK_CONTROLLER_BLOCK = REGISTRY.BLOCKS.register("track_work_controller", () -> new TrackWorkController(BlockBehaviour.Properties.of().mapColor(MapColor.STONE)));

            TRACK_WORK_CONTROLLER_BLOCK_ENTITY = REGISTRY.BLOCK_ENTITIES.register("track_work_controller", () -> BlockEntityType.Builder.of(TrackWorkControllerEntity::new, TRACK_WORK_CONTROLLER_BLOCK.get()).build(null));
        });

        //Utils.executeIsModEnable("drivebywire", () -> {
        //    WIRE_NETWORK_HUB_BLOCK = REGISTRY.BLOCKS.register("wire_network_hub", () -> new WireNetworkHubBlock(BlockBehaviour.Properties.of().mapColor(MapColor.STONE)));
        //});

        NETWORK_MODEM.register(REGISTRY);
        NETWORK_MODEM.register(builder);

        builder.push((registry) -> {
            Utils.executeIsModEnable("trackwork", () -> {
                TRACK_WORK_CONTROLLER_ITEM = registry.register("track_work_controller", () -> new BlockItem(TRACK_WORK_CONTROLLER_BLOCK.get(), new Item.Properties().rarity(Rarity.EPIC)));
            });

            //Utils.executeIsModEnable("drivebywire", () -> {
            //    WIRE_NETWORK_HUB_ITEM = registry.register("wire_network_hub", () -> new BlockItem(WIRE_NETWORK_HUB_BLOCK.get(), new Item.Properties().rarity(Rarity.EPIC)));
            //});
        });
    }
}
