package io.p2vman.vmodextras.cc.block;

import edn.stratodonut.drivebywire.wire.MultiChannelWireSource;

import io.p2vman.vmodextras.util.CollectorFactory;
import it.unimi.dsi.fastutil.objects.ObjectArrayList;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.state.BlockBehaviour;

import javax.annotation.Nonnull;
import java.util.List;
import java.util.Random;
import java.util.stream.IntStream;

public class WireNetworkHubBlock extends Block implements MultiChannelWireSource {
    private static final List<String> channels;
    public WireNetworkHubBlock(BlockBehaviour.Properties p_49795_) {
        super(p_49795_);
    }

    public List<String> wire$getChannels() {
        return channels;
    }

    @Nonnull
    public String wire$nextChannel(String current, boolean forward) {
        int curIndex = channels.indexOf(current);
        return curIndex == -1 ? channels.get(0) : channels.get(Math.floorMod(curIndex + (forward ? 1 : -1), channels.size()));
    }

    private static final String CHARACTERS = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";

    static {
        long seed = 123456789L;
        int prefixCount = 4;
        int perPrefix = 5;

        channels = new Random(seed)
                .ints(prefixCount, 0, CHARACTERS.length() * CHARACTERS.length())
                .mapToObj(i -> "" + CHARACTERS.charAt(i / CHARACTERS.length()) + CHARACTERS.charAt(i % CHARACTERS.length()))
                .flatMap(prefix -> IntStream.range(0, perPrefix).mapToObj(i -> prefix + i))
                .collect(CollectorFactory.toList(ObjectArrayList::new));
    }
}
