package io.p2vman.vmodextras.compact;

import io.p2vman.vmodextras.cc.ComputerCraftCompact;
import io.p2vman.vmodextras.trackwork.TrackWorkCompact;
import io.p2vman.vmodextras.util.Utils;
import net.minecraft.world.item.CreativeModeTab;
import net.minecraft.world.item.Items;
import net.minecraftforge.registries.RegistryObject;
import io.p2vman.vmodextras.VmodExtras;
import io.p2vman.vmodextras.util.ModRegistry;
import java.util.function.BiConsumer;

public class Compact {
    public static RegistryObject<CreativeModeTab> COMPACT_TAB;

    public Compact(BiConsumer<ModRegistry, ModRegistry.TabBuilder> consumer) {
        ModRegistry REGISTRY = VmodExtras.REGISTRY;
        ModRegistry.TabBuilder builder = REGISTRY.TabBuilder();

        Utils.executeIsModEnable("computercraft", () -> {
            ComputerCraftCompact.init(REGISTRY, builder);
        });

        Utils.executeIsModEnable("trackwork", () -> {
           TrackWorkCompact.init(REGISTRY, builder);
        });

        consumer.accept(REGISTRY, builder);

        COMPACT_TAB = builder.build("vmodextras", Items.PAPER.getDefaultInstance());
    }
}
