package io.p2vman.vmodextras.mixins.create_tweaked_controllers;

import com.getitemfromblock.create_tweaked_controllers.block.TweakedLecternControllerBlockEntity;
import com.simibubi.create.content.redstone.link.controller.LecternControllerBlockEntity;
import com.simibubi.create.content.schematics.requirement.ISpecialBlockItemRequirement;
import com.simibubi.create.foundation.block.IBE;
import io.p2vman.vmodextras.GameRulesBlat;
import net.minecraft.client.Minecraft;
import net.minecraft.client.player.AbstractClientPlayer;
import net.minecraft.core.BlockPos;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.InteractionResult;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.level.GameType;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.LecternBlock;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.phys.BlockHitResult;
import org.spongepowered.asm.mixin.Mixin;
import com.getitemfromblock.create_tweaked_controllers.block.TweakedLecternControllerBlock;
import org.spongepowered.asm.mixin.Overwrite;
import org.spongepowered.asm.mixin.Shadow;

@Mixin(value = TweakedLecternControllerBlock.class, priority = 0)
public abstract class TweakedLecternControllerBlockMixin extends LecternBlock implements IBE<TweakedLecternControllerBlockEntity>, ISpecialBlockItemRequirement {
    @Shadow
    public abstract void replaceWithLectern(BlockState state, Level world, BlockPos pos);

    public TweakedLecternControllerBlockMixin(BlockBehaviour.Properties properties) {
        super(properties);
        this.registerDefaultState(this.defaultBlockState().setValue(HAS_BOOK, true));
    }

    /**
     * @author
     * @reason
     */
    @Overwrite
    public InteractionResult use(BlockState state, Level world, BlockPos pos, Player player, InteractionHand hand, BlockHitResult hit) {
        if (!player.isShiftKeyDown() && TweakedLecternControllerBlockEntity.playerInRange(player, world, pos)) {
            if (!world.isClientSide) {
                this.withBlockEntityDo(world, pos, (be) -> {
                    be.tryStartUsing(player);
                });
            }

            return InteractionResult.SUCCESS;
        } else if (player.isShiftKeyDown()) {
            if (!world.isClientSide) {
                if (!world.getGameRules().getBoolean(GameRulesBlat.EX4)) {
                    if (player instanceof ServerPlayer f && f.gameMode.getGameModeForPlayer() != GameType.ADVENTURE) {
                        this.replaceWithLectern(state, world, pos);
                        return InteractionResult.SUCCESS;
                    }
                }
                else {
                    this.replaceWithLectern(state, world, pos);
                    return InteractionResult.SUCCESS;
                }
            }
            return InteractionResult.PASS;
        } else {
            return InteractionResult.PASS;
        }
    }
}
