package io.p2vman.vmodextras.mixins.trackwork;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import edn.stratodonut.trackwork.tracks.forces.PhysicsTrackController;
import org.joml.Math;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Overwrite;
import org.spongepowered.asm.mixin.Shadow;
import io.p2vman.vmodextras.Config;
import io.p2vman.vmodextras.trackwork.IPhysicsTrackController;

@Mixin(PhysicsTrackController.class)
@JsonIgnoreProperties(ignoreUnknown = true)
public abstract class PhysicsTrackControllerMixin implements IPhysicsTrackController {
    @Shadow(remap = false) private volatile float suspensionStiffness;

    /**
     * @author
     * @reason
     */
    @Overwrite(remap = false)
    public final float setDamperCoefficient(float delta) {
        this.suspensionStiffness = Math.clamp(1, Config.Suspension_Stiffness_LIMIT.get(), this.suspensionStiffness + delta);
        return this.suspensionStiffness;
    }
}
