package io.p2vman.vmodextras.trackwork;

import edn.stratodonut.trackwork.tracks.forces.PhysicsTrackController;
import edn.stratodonut.trackwork.tracks.forces.SimpleWheelController;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.nbt.Tag;
import org.joml.Vector3d;
import org.joml.Vector3dc;
import org.valkyrienskies.core.api.ships.ServerShip;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

public interface IController {
    float getSuspensionStiffness();
    void setSuspensionStiffness(float val);
    @Nonnull Vector3dc getSuspensionAdjust();
    void setSuspensionAdjust(@Nonnull Vector3dc vector3d);

    int SimpleWheel = 0;
    int PhysicsTrack = 1;

    static @Nullable IController getInstance(@Nonnull ServerShip ship, int id) {
        switch (id) {
            case IController.SimpleWheel -> {
                return ((IController) SimpleWheelController.getOrCreate(ship));
            }
            case IController.PhysicsTrack -> {
                return ((IController) PhysicsTrackController.getOrCreate(ship));
            }
            default -> {
                return null;
            }
        }
    }
}
